︠4e7b1645-9d95-43ef-98de-16e99c1c4f90︠
from operator import mul
def W(n):
    return reduce(mul, range(1,2*n,2))
def L(n):
    if (n==1):
        return 1
    else:
        return reduce(mul, range(2,2*n,2))
︡b104c856-1404-4be4-bc3d-4d4c489828a9︡︡
︠c5356896-842f-4656-979d-087e625f936e︠
def bp(n, k, v):
  result = 0
  for p in Partitions(n, length=k).list():
    factorialProduct = 1
    powerFactorialProduct = 1
    for index in set(p):
      count = list(p).count(index)
      factorialProduct = factorialProduct * factorial(count)
      powerFactorialProduct = powerFactorialProduct * factorial(index)^count
    coefficient = factorial(n) / (factorialProduct * powerFactorialProduct)
    result = result + coefficient * reduce(mul, [v[i-1] for i in p])
  return result
︡9e03e6c4-8423-4610-8b35-332e7319b6f1︡︡
︠82de314f-c829-43d3-a0a9-66f9b94c1545︠
def shoelaceExpectationNumerator(n):
    # build vector of L1...Ln
    v = []
    for i in range(1,n+1):
        v.append(L(i))
    sum = 0
    for i in range(1,n+1):
        sum = sum + i*bp(n,i,v)
    return sum
︡87bce255-5eef-4808-b594-28a0597c8e5b︡︡
︠20a36ed3-1db8-4d8d-a95e-06a0e960f9d5︠
def shoelaceExpectation(n):
    return float(shoelaceExpectationNumerator(n))/W(n)
︡8b72809a-0dd2-411b-b09b-b76d9a79775b︡︡
︠eba3ea19-0bb1-4d6e-ab7c-80d527ed028a︠
print shoelaceExpectation(2)
print shoelaceExpectation(3)
print shoelaceExpectation(4)
print shoelaceExpectation(30)
︡be722991-d465-4451-a87e-0fb17a0c19df︡{"stdout": "1.33333333333\n1.53333333333\n1.67619047619\n2.68237684749"}︡
